<?php
/**
* @ 2013 Benj Golding. All rights reserved.
* @GNU/GPL licence
*
*/

// Assert file included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
* YouTube Content Plugin
*
*/
class plgContentYtp extends JPlugin
{

	/**
	* Ctor
	*
	* @param object $subject The object to observe
	* @param object $params The object that holds the plugin parameters
	*/
	//function PluginYoutube( &$subject, $params )
	function plgContentYtp( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	/**
	* Example prepare content method
	*
	* Method is called by the view
	*
	* @param object The article object. Note $article->text is also available
	* @param object The article params
	* @param int The 'page' number
	*/
	function onContentPrepare( $context, &$article, &$params, $page = 0)
	{

		if ( JString::strpos( $article->text, '{youtube}' ) === false ) {
			return true;
		}
		
		$article->text = preg_replace('|{youtube}(.*){\/youtube}|e', '$this->embedVideo("\1")', $article->text);

		return true;
	
	}

	function embedVideo($vCode)
	{

	 	$params = $this->params;
		
		$embed 				= $params->get('embed', 'iframe');
		$width 				= $params->get('width', 425);
		$height 				= $params->get('height', 344);
		$autoplay 			= $params->get('autoplay', 0);
		$autohide 			= $params->get('autohide', 0);
		$cc_load_policy 	= $params->get('cc_load_policy', 0);
		$color 				= $params->get('color', 'red');
		$controls 			= $params->get('controls', 1);
		$disablekb 			= $params->get('disablekb', 0);
		$fs 					= $params->get('fs', 1);
		$showinfo 			= $params->get('showinfo', 1);
		$theme 				= $params->get('theme', 'dark');
		
		// Initialization options
		if ($autoplay == 1) { $autoplay = '&autoplay=1'; } else { $autoplay = ''; }
		if ($autohide == 1) { $autohide = '&autohide=1'; } else { $autohide = ''; }
		if ($cc_load_policy == 1) { $cc_load_policy = '&cc_load_policy=1'; } else { $cc_load_policy = ''; }
		if ($color == 'white') { $color = '&color=white'; } else { $color = ''; }
		if ($controls == 0) { $controls = '&controls=0'; } else { $controls = ''; }
		if ($disablekb == 1) { $disablekb = '&disablekb=1'; } else { $disablekb = ''; }
		if ($fs == 0) { $fs = '&fs=0'; } else { $fs = ''; }
		if ($showinfo == 0) { $showinfo = '&showinfo=0'; } else { $showinfo = ''; }
		if ($theme == 'light') { $theme = '&theme=light'; } else { $theme = ''; }
		
		$templ = explode('|',$vCode);
		
		$vCode = $templ[0];
		if (!empty($templ[1])) { $width = $templ[1]; }
		if (!empty($templ[2])) { $height = $templ[2]; }
		if (!empty($templ[3]) && $templ[3] == 1) { $autoplay = '&autoplay=1'; }
		
		$proto = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off' ? 'https' : 'http';
		
		$other_option = $autoplay.$autohide.$cc_load_policy.$color.$controls.$disablekb.$fs.$showinfo.$theme;
			
		if ($embed == 'object') { 
			$result = '<object width="'.$width.'" height="'.$height.'"><param name="movie" value="'.$proto.'://www.youtube.com/v/'.$vCode.'?version=3'.$other_option.'" /><param name="allowFullScreen" value="true" /><param name="allowScriptAccess" value="always" /><embed src="'.$proto.'://www.youtube.com/v/'.$vCode.'?version=3'.$other_option.'" type="application/x-shockwave-flash" allowfullscreen="true" allowScriptAccess="always" width="'.$width.'" height="'.$height.'" /></object>';
		} else {
			$result = '<iframe id="ytplayer" type="text/html" width="'.$width.'" height="'.$height.'" src="'.$proto.'://www.youtube.com/embed/'.$vCode.'?version=3'.$other_option.'" frameborder="0" allowfullscreen></iframe>';
		}

		return $result;
	}

}
